#ifndef _FUNC_PROTO_H_
#define _FUNC_PROTO_H_

/*
 * Insert sg.o into the kernel
 */
void insertModule();

/*
 * Remove sg.o from the kernel
 */
void removeModule( int flg );

/*
 * Selection of device interactively
 */
char *deviceSel( char *dev );

/*
 * Print help menu. Does not return.
 */
void printHelp();

/*
 * Make an inquiry on a device opened by fd
 */
int inquiry( int fd, void *buf );

/*
 * Get useful information on device
 */
void devinfo( char *dev );

/*
 * String->Number check
 */
int isnumber( char *arg );

/*
 * Work function
 * Do the I/O on a file descriptor
 */
void workr( int off );
void workw( int off );

/*
 * sgBufInit function used to initialize sg_io_hdr_t 
 * structs.
 */
void sgBufInit( sg_io_hdr_t *buf );

/*
 * Set the lba address in cmd block
 */
void sgBufSet( sg_io_hdr_t *buf );

/*
 * Set up the SIGPOLL sigaction
 */
void setSignal();
void sigPoll( int sig, siginfo_t *si, void *data );
void catchC();

/*
 * Return offset for fd in fd[]
 */
int offFd( int d );

/*
 * Read the capacity of the drive and block size
 */
int readcap( int fd, int *blk );

/*
 * Read outstanding I/O's before quit.
 */
void outstanding();

/*
 * Clean SG.o resources
 */
void cleanSg();

#endif
