#include "header.h"

int inquiry( int sg_fd, void * resp ) 
{
  unsigned char inqCmdBlk[6] = {INQUIRY, 0, 0, 0, 0, 0};
  unsigned char sense_b[32];
  sg_io_hdr_t io_hdr;

  inqCmdBlk[4] = (unsigned char)255;

  memset(&io_hdr, 0, sizeof(sg_io_hdr_t));

  io_hdr.interface_id = 'S';
  io_hdr.cmd_len = sizeof(inqCmdBlk);
  io_hdr.mx_sb_len = sizeof(sense_b);
  io_hdr.dxfer_direction = SG_DXFER_FROM_DEV;
  io_hdr.dxfer_len = 255;
  io_hdr.dxferp = resp;
  io_hdr.cmdp = inqCmdBlk;
  io_hdr.sbp = sense_b;
  io_hdr.timeout = 6000;

  if ( ioctl(sg_fd, SG_IO, &io_hdr) < 0 ) 
  {
    perror("inquiry()");
    return 1;
  }

  return 0;
}

